/******************************************************************************/
/*  (C) COPYRIGHT International Business Machines Corp. 1993                  */
/*                            All Rights Reserved                             */
/*                                                                            */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION PROVIDES THIS MATERIAL        */
/*  "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,        */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND FITNESS FOR A PARTICULAR PURPOSE.                                     */
/*                                                                            */
/******************************************************************************/
#include <X11/PEX5/PEXlib.h>
#include <X11/PEX5/PEXExtlib.h>
#include <misc.h>

/****************************************************************************
 *   No primitives drawn in this test                                       *
 ***************************************************************************/
void draw_model(Display          *dpy,
               XID              resourceID,
               PEXOCRequestType req_type)
{
  int                tmcount, domain;
  unsigned int       paramtype, order, numtmid, paramdata;
  PEXExtTextureMap   test_tm[3];
  PEXExtTMDomainData domain_data;
  PEXExtTexelArray   texel_arrays[3];
  char               imp_dep[] = "Imp Dep Data";  
  PEXExtTMParameterizationData parama;
  PEXExtTMParameterizationData paramb;
  PEXExtTMParameterizationData paramc;
  PEXExtTMParameterizationData testparam;
  
  PEXExtTMDescription test_tmd;

  PEXExtTexelRGB     rgb1[12] = {1,2,3,4,5,6,7,8,9,10,11,12};
  PEXExtTexelRGB     rgb2[12] = {13,14,15,16,17,18,19,20,21,22,23,24};
  PEXExtTexelRGB     rgb3[12] = {25,26,27,28,29,30,31,32,33,34,35,36};

  parama.data.reflection.matrix[0][0] = 1.0;                     
  parama.data.reflection.matrix[0][1] = 0.0;                     
  parama.data.reflection.matrix[0][2] = 0.0;                     
  parama.data.reflection.matrix[0][3] = 0.0;                     
  parama.data.reflection.matrix[1][0] = 0.0;                     
  parama.data.reflection.matrix[1][1] = 1.0;                     
  parama.data.reflection.matrix[1][2] = 0.0;                     
  parama.data.reflection.matrix[1][3] = 0.0;                     
  parama.data.reflection.matrix[2][0] = 0.0;                     
  parama.data.reflection.matrix[2][1] = 0.0;                     
  parama.data.reflection.matrix[2][2] = 1.0;                     
  parama.data.reflection.matrix[2][3] = 0.0;                     
  parama.data.reflection.matrix[3][0] = 0.0;                     
  parama.data.reflection.matrix[3][1] = 0.0;                     
  parama.data.reflection.matrix[3][2] = 0.0;                     
  parama.data.reflection.matrix[3][3] = 1.0;                     

  paramb.data.linear.p0[0] = 2.2;                     
  paramb.data.linear.p0[1] = 3.1;                     
  paramb.data.linear.p0[2] = 1.7;                     
  paramb.data.linear.p0[3] = 4.3;                     
  paramb.data.linear.p1[0] = 6.0;                     
  paramb.data.linear.p1[1] = 2.4;                     
  paramb.data.linear.p1[2] = 2.9;                 
  paramb.data.linear.p1[3] = 5.0;                  

  paramc.data.imp_dep.length =  strlen(imp_dep);     
  paramc.data.imp_dep.imp_dep = imp_dep;            

  domain_data.data.color.tm_type = PEXExtTMTypeMipMap;
  domain_data.data.color.texel_type = PEXExtTexelRGBFloat;
  domain_data.data.color.num_levels = 1;
  domain_data.data.color.tm_type_data.length = strlen(imp_dep);
  domain_data.data.color.tm_type_data.imp_dep = imp_dep;
 
  texel_arrays[0].array.rgb = rgb1;
  texel_arrays[0].dimension.t0 =  1;   
  texel_arrays[0].dimension.t1 =  1;   
  texel_arrays[0].dimension.t2 = 10;
  domain=PEXExtTMDomainColor2D;  
  test_tm[0] = PEXExtCreateTM(dpy, domain, &domain_data, texel_arrays);

  domain_data.data.color.num_levels = 2;
  texel_arrays[0].array.rgb = rgb1;
  texel_arrays[1].array.rgb = rgb2;
  texel_arrays[0].dimension.t0 =  1;   
  texel_arrays[0].dimension.t1 =  1;   
  texel_arrays[0].dimension.t2 = 10;
  texel_arrays[1].dimension.t0 =  1;   
  texel_arrays[1].dimension.t1 =  2;   
  texel_arrays[1].dimension.t2 = 10;
  test_tm[1] = PEXExtCreateTM(dpy, domain, &domain_data, texel_arrays);

  domain_data.data.color.num_levels = 3;
  texel_arrays[0].array.rgb = rgb1;
  texel_arrays[1].array.rgb = rgb2;
  texel_arrays[2].array.rgb = rgb3;
  texel_arrays[0].dimension.t0 =  1;   
  texel_arrays[0].dimension.t1 =  1;   
  texel_arrays[0].dimension.t2 = 10;
  texel_arrays[1].dimension.t0 =  1;   
  texel_arrays[1].dimension.t1 =  2;   
  texel_arrays[1].dimension.t2 = 10;
  texel_arrays[2].dimension.t0 =  1;   
  texel_arrays[2].dimension.t1 =  3;   
  texel_arrays[2].dimension.t2 = 10;
  test_tm[2] = PEXExtCreateTM(dpy, domain, &domain_data, texel_arrays);

  for(paramtype=PEXExtTMParamExplicit; 
        paramtype<=PEXExtTMParamLinearVRC; paramtype++) {
   for(paramdata=1; paramdata<=3; paramdata++) {
    for(order=PEXExtTMRenderingOrderPreSpecular; 
        order<=PEXExtTMRenderingOrderPostSpecular; order++) {
     for(numtmid=1; numtmid<=3; numtmid++) { 
       switch(paramdata) {
         case 1: testparam = parama; break;
         case 2: testparam = paramb; break;
         case 3: testparam = paramc; break;
       }
       switch(numtmid) {
         case 1: tmcount = 1; break;
         case 2: tmcount = 2; break;
         case 3: tmcount = 3; break;
       }
/* Get the texture map description */
       test_tmd = PEXExtCreateTMDescription(dpy, paramtype, 
         &testparam, order, tmcount, test_tm); 
/* Lets see if we can free it up */
       PEXExtFreeTMDescription(dpy, test_tmd);
     }
    }
   }
  }
}

/****************************************************************************
 *  Sets the test parameters                                                *
 ***************************************************************************/
void inquire_test_params(char *test_name,
                         int  *num_images,
                         int  *supported_modes,
                         char *win_title)


{
    strcpy(test_name, "Create Texture Map Description");
    *num_images = 1;
    *supported_modes = IMM_MODE | STR_MODE;

    strcpy(win_title, "PEX Create Texture Map Description Test");
}


/****************************************************************************
 *  This routine is used to do miscellaneous things like setting some       *
 *  renderer attributess, Viewing etc if needed.                            *
 ***************************************************************************/
void misc_setup(Display *dpy, Window window, PEXRenderer renderer,
                int cur_image)
{
   _ibmpex_set_stderr("createtmdes.txt", "createtmdes");
}

/****************************************************************************
 *  This routine calls the function which does the actual test              *
 ***************************************************************************/
void execute_test(Display *dpy, XID resourceID,
               PEXOCRequestType req_type, int cur_image)
{
    describe_test( "\n" );
    describe_test( " IBM Create Texture Map Description Test:\n");
    describe_test( "\n" );
    describe_test( " This test will perform the following:\n");
    describe_test( "\n" );
    describe_test( "   All possible combinations of TM Parameterization Data,\n"); 
    describe_test( "   Rendering Order, an TM count will be fed into a PEXExtCreateTM\n"); 
    describe_test( "   PEXExtCreateTMDescription call.\n\n"); 
    describe_test( "\n"); 
    _ibmpex_stderr_print("If you don't get any error messages, then the test passes.\n");

    draw_model(dpy, resourceID, req_type);

}

void testproc(Display *dpy, Window window, int cur_image)
{
    file_testproc("createtmdes.txt", "createtmdes");
}

